/* dpt_txdel.ps.c */                                                       
/* Default transmission delay model for pt-to-pt link Transceiver Pipeline */

/****************************************/
/*		  Copyright (c) 1994			*/
/*			by MIL 3, Inc.				*/
/*		(A Delaware Corporation)		*/
/*	3400 International Drive,  N.W.		*/
/*		Washington, D.C., U.S.A.		*/
/*			All Rights Reserved.		*/
/****************************************/

#include <opnet.h>

#define IGMP_PROTOCOL_ID  9
#define UDP_PROTOCOL_ID   20
#define RSVP_PROTOCOL_ID  46
#define QOSPF_PROTOCOL_ID 89
Anvid vid;

void
li_anim_dpt_txdel (pkptr)
	Packet*		pkptr;
	{
	/*Pradeep's*=====*/
        Objid       link_objid;
        char        link_name [128];
	int 	prot,grp,node;
	/*=======*/
	Objid		tx_ch_obid;
	int			pklen;
	double		tx_drate, tx_delay;

	/** Compute transmission delay associated with a	**/
	/** packet transmission on a point-to-point link.	**/
	FIN (dpt_txdel (pkptr))

	/* Obtain object id of transmitter channel forwarding transmission. */
	tx_ch_obid = op_td_get_int (pkptr, OPC_TDA_PT_TX_CH_OBJID);

	/* Obtain the transmission rate of that channel. */
	op_ima_obj_attr_get (tx_ch_obid, "data rate", &tx_drate);

	/* Obtain length of packet. */
	pklen = op_pk_total_size_get (pkptr);
	op_pk_nfd_get(pkptr,"prot_id", &prot);
	op_pk_nfd_get(pkptr, "dest_node",&grp);
	/* Compute time required to complete transmission of packet. */
	tx_delay = pklen / tx_drate;

	/* Place transmission delay in packet transmission data attribute. */
	op_td_set_dbl (pkptr, OPC_TDA_PT_TX_DELAY, tx_delay);

      /**************************/
      /* Begin animation calls. */
      /**************************/
 
      /* Obtain the object id of the link on      */
      /* on which this packet is traversing.      */
      link_objid = op_td_get_int (pkptr, OPC_TDA_PT_LINK_OBJID);
 
      /* Obtain the link name.                    */
      op_ima_obj_attr_get (link_objid, "name", link_name);
 
      /* Rendezvous with auto anim. The argument  */
      /* to the following procedure (Anim-44/5.0) */
          /* should match the label of the custom     */
      /* animation probe object.                  */
      vid = op_anim_lprobe_anvid ("TEST");

  
      /* Depending upon the type of the message   */
      /* (i.e., packet field content) change the  */
      /* link color. As an example, the following */
      /* code changes the color to RED for each   */
      /* packet traversing the duplex link.       */
      /* Refer Anim-40/5.0 for details on this.   */
     if(prot == IGMP_PROTOCOL_ID){
	  /*  printf("IGMP  packet on the link\n");  */
      op_anim_ime_nobj_update (vid, OPC_ANIM_OBJTYPE_SIMPLINK, link_name,
          OPC_ANIM_OBJ_ATTR_COLOR, OPC_ANIM_COLOR_BLUE, OPC_EOL);}
     if(prot == QOSPF_PROTOCOL_ID){
		/*  printf("QOSPF packet on the link\n");  */
      op_anim_ime_nobj_update (vid, OPC_ANIM_OBJTYPE_SIMPLINK, link_name,
          OPC_ANIM_OBJ_ATTR_COLOR, OPC_ANIM_COLOR_RED, OPC_EOL);}
     if(prot == RSVP_PROTOCOL_ID){
		/*  printf("RSVP packet on the link\n");  */
      op_anim_ime_nobj_update (vid, OPC_ANIM_OBJTYPE_SIMPLINK, link_name,
          OPC_ANIM_OBJ_ATTR_COLOR, OPC_ANIM_COLOR_YELLOW, OPC_EOL);}
/*     if(prot == UDP_PROTOCOL_ID && grp == 1)
      op_anim_ime_nobj_update (vid, OPC_ANIM_OBJTYPE_SIMPLINK, link_name,
          OPC_ANIM_OBJ_ATTR_COLOR, OPC_ANIM_COLOR_ORANGE, OPC_EOL);
*/
     if(prot != UDP_PROTOCOL_ID  && prot != IGMP_PROTOCOL_ID && 
		prot != RSVP_PROTOCOL_ID && prot != QOSPF_PROTOCOL_ID)
			op_sim_end("Hey error in protocol value\n","","",""); 
      /************************/
      /* End animation calls. */
      /************************/


	FOUT
	}                
